<template lang="pug">
q-banner.z-max.bg-rip1.text-white.q-pa-sm.q-px-lg.drop
  .row.items-center(v-if="countDown")
    .col-6.col-sm-3.col-md-2.col-xl-1.text-left
      .row.text-uppercase.text-left
        .col.text-caption.cap1 {{ $t('phase.phase_submit') }}
      .row.text-h6.text-weight-bolder(style="line-height: 1")
        .col {{ display.days }} :
        .col {{ display.hours }} :
        .col {{ display.mins }} :
        .col {{ display.seconds }}
      .row.justify-around.text-left
        .col {{ $t('countdown_day') }}
        .col {{ $t('countdown_hour') }}
        .col {{ $t('countdown_minute') }}
        .col {{ $t('countdown_second') }}
    .col-6.col-sm-9.col-md-10.col-xl-11.text-right
      q-btn(
        rounded,
        outline,
        size="md",
        @click="$emit('submit')",
        :class="{ 'q-mt-lg': $q.screen.lt.sm }"
      ) {{ $t('submit_now') }}
  .row
</template>

<script>
import { crono } from "vue-crono";
import { DateTime, Interval } from "luxon";
import { mapActions, mapState } from "vuex";
import find from "lodash/find";

export default {
  mixins: [crono],
  async created() {},
  async mounted() {
    await this.initConfig();
  },
  methods: {
    ...mapActions(["initConfig"]),
    loadTime() {
      if (this.currentThingToCountdownTo) {
        const currentTime = DateTime.now();
        let i;
        if (this.currentThingToCountdownTo <= currentTime)
          i = Interval.fromDateTimes(
            this.currentThingToCountdownTo,
            currentTime
          );
        else
          i = Interval.fromDateTimes(
            currentTime,
            this.currentThingToCountdownTo
          );
        this.countDown = i.toDuration();
      }
    },
  },
  data() {
    return {
      countDown: undefined,
    };
  },
  computed: {
    ...mapState(["config"]),
    display() {
      let secs = this.countDown.as("seconds");

      let days = Math.floor(secs / 86400)
        .toString()
        .padStart(2, 0);
      let leftover = secs % 86400;
      let hours = Math.floor(leftover / 3600)
        .toString()
        .padStart(2, 0);
      leftover = leftover % 3600;
      let mins = Math.floor(leftover / 60)
        .toString()
        .padStart(2, 0);
      leftover = leftover % 60;
      let seconds = Math.floor(leftover).toString().padStart(2, 0);

      return {
        days,
        hours,
        mins,
        seconds,
      };
    },
    currentThingToCountdownTo() {
      if (this.config) {
        let phase = find(this.config.phases, {
          code: "submit",
        });
        return DateTime.fromSeconds(phase.closesAt._seconds);
      } else return 0;
    },
  },
  cron: {
    time: 1000,
    method: "loadTime",
    autoStart: true,
  },
};
</script>

<style scoped>
.cap1 {
  font-size: 1em;
}

.bg-rip1 {
  background-color: transparent;
  background-image: url("~@/assets/img/ticker_bg.png");
  background-position-y: top;
  background-position-x: center;
  background-size: cover;
  background-repeat: no-repeat;
  padding-top: 50px;
  min-height: 118px;
}

.drop {
  filter: drop-shadow(0 0 0.75rem #00000066);
}
</style>
